#!/usr/bin/python
"""
This file is part of The Free Python Web Server Project (FreePyWebServer).
Copyright (C) 2008 Collin Ross Mechlowitz Stocks.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 or later of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

HOST,PORT="",8080
CONCURRENT=8

import socket,sys,time,thread

import http

if 1<len(sys.argv):
	try:
		PORT=int(sys.argv[1])
	except ValueError:
		print>>sys.stderr,"Argument 1 must be an integer."

def eventLoop(sock):
	while True:
		try:
			s,addr=sock.accept()
			try:
				http.process(s,addr)
			except:
				try:
					s.close()
				except:
					pass
		except socket.error:
			try:
				sock.close()
			except:
				pass
			break
		except:
			pass

while True:
	sock=socket.socket()
	try:
		sock.bind((HOST,PORT))
	except socket.error:
		print>>sys.stderr,"HOST or PORT invalid."
		break
	for i in range(CONCURRENT-1):
		thread.start_new_thread(eventLoop,(sock,))
	eventLoop(sock) # use this thread, too!

print>>sys.stderr,"The server has had a complete and utter failure. Good luck figuring out what the hell happened and trying to fix it."

